/******************************************************************************** 
Desarrollado por:   Avanxo México
Autor:              Héctor Figueroa
Proyecto:           TOYOTA TAM
Descripción:        Clase que contiene la logica para activar o desactivar los usuarios de seguimiento de lead Manegment

Infomación de cambios (versiones)
===============================================================================
No.    Fecha             Autor                       Descripcion
1.0    10-Sep-2020       Héctor Figueroa             Creación
******************************************************************************* */

public without sharing class TAM_ActivaUsrSegLeadMangCtrl {
    
    public class wrpListaUsuariosDist{
        @AuraEnabled public String strNombreUusario {get;set;}    
        @AuraEnabled public String strAlias {get;set;}
        @AuraEnabled public String strEmail {get;set;}    
        @AuraEnabled public String strPuesto {get;set;}    
        @AuraEnabled public String strPerfil {get;set;}    
        @AuraEnabled public Boolean blnActivo {get;set;}    
        @AuraEnabled public Integer intTotalLeads {get;set;}    
        @AuraEnabled public String strIdUsuario {get;set;}    
        @AuraEnabled public Integer intTotalLeads2 {get;set;}    
        @AuraEnabled public Integer intTotalLeads3 {get;set;}    
        @AuraEnabled public Integer SumaIntTotallead {get;set;} 
        @AuraEnabled public String strCodigoDealer {get;set;}         
        @AuraEnabled public Boolean blnMuestCodDealer {get;set;}    

        //Un contructor por default
        public wrpListaUsuariosDist(){
            this.strNombreUusario = '';
            this.strAlias = '';
            this.strEmail = '';
            this.strPuesto = '';
            this.strPerfil = '';
            this.blnActivo = false;
            this.strIdUsuario = '';
            this.intTotalLeads = 0;
            this.intTotalLeads2 = 0;
            this.intTotalLeads3 = 0;
            this.strCodigoDealer = '';
        }
        
        //Un contructor por default
        public wrpListaUsuariosDist(String strNombreUusario, String strAlias, String strEmail, String strPuesto, String strPerfil, 
                                    Boolean blnActivo, String strIdUsuario, Integer intTotalLeads, Integer intTotalLeads2, Integer intTotalLeads3){
            this.strNombreUusario = strNombreUusario.toUpperCase();
            this.strAlias = strAlias.toUpperCase();            
            this.strEmail = strEmail;
            this.strPuesto = strPuesto;
            this.strPerfil = strPerfil;
            this.blnActivo = blnActivo;
            this.strIdUsuario = strIdUsuario;
            this.intTotalLeads = intTotalLeads;
            this.intTotalLeads2 = intTotalLeads2;
            this.intTotalLeads3 = intTotalLeads3;
            this.SumaIntTotallead = intTotalLeads + intTotalLeads2;
        }
    }

    public class wrpDelaerUsruario{
        @AuraEnabled public List<wrpDelaer> lDealers {get;set;} 
        @AuraEnabled public List<wrpListaUsuariosDist> lUsuarios {get;set;} 
        @AuraEnabled public wrpDealerRedirect objWrpDealerRedirect {get;set;} 
        @AuraEnabled public List<wrpListaUsuariosDist> lUsuariosRedirect {get;set;} 
        @AuraEnabled public Boolean blnLstReasigLeads {get;set;}    
        @AuraEnabled public Boolean blnGestorLeads {get;set;}    
        @AuraEnabled public List<wrpDelaerRel> lWrpDealerRel {get;set;} 
        
        //Un contrusctor por default
        public wrpDelaerUsruario(){
            this.lDealers = new List<wrpDelaer>();
            this.lUsuarios = new List<wrpListaUsuariosDist>();
            this.objWrpDealerRedirect = new wrpDealerRedirect();
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpDelaerUsruario(List<wrpDelaer> lDealers, List<wrpListaUsuariosDist> lUsuarios,
            wrpDealerRedirect objWrpDealerRedirect){
            this.lDealers = lDealers;
            this.lUsuarios = lUsuarios;
            this.objWrpDealerRedirect = objWrpDealerRedirect;            
        }//Fin si wrpListaDealers        
    }

    public class wrpDelaerRel{
        @AuraEnabled public wrpDelaer objDealer {get;set;} 
        @AuraEnabled public List<wrpListaUsuariosDist> lUsrsRel {get;set;} 

        //Un contrusctor por default
        public wrpDelaerRel(){
            this.objDealer = new wrpDelaer();
            this.lUsrsRel = new List<wrpListaUsuariosDist>();
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpDelaerRel(wrpDelaer objDealer, List<wrpListaUsuariosDist> lUsrsRel){
            this.objDealer = objDealer;
            this.lUsrsRel = lUsrsRel;
        }//Fin si wrpListaDealers        
    }
    
    public class wrpDelaer{
        @AuraEnabled public String codigo {get;set;} 
        @AuraEnabled public String nombreDist {get;set;} 

        //Un contrusctor por default
        public wrpDelaer(){
            this.codigo = '';
            this.nombreDist = '';
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpDelaer(String codigo, String nombreDist){
            this.codigo = codigo;
            this.nombreDist = nombreDist;
        }//Fin si wrpListaDealers        
    }

    public class wrpDealerRedirect{
        @AuraEnabled public String codigo {get;set;}         
        @AuraEnabled public String nombre {get;set;} 
        @AuraEnabled public String codigoOrigen {get;set;}         

        //Un contrusctor por default
        public wrpDealerRedirect(){
            this.codigo = '';            
            this.nombre = '';
            this.codigoOrigen = '';            
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpDealerRedirect(String codigo, String nombre, String codigoOrigen){
            this.codigo = codigo;
            this.nombre = nombre;
            this.codigoOrigen = codigoOrigen;
        }//Fin si wrpListaDealers        
    }

    public class wrpUserRedirect{
        @AuraEnabled public String nombreUsuarioSdf {get;set;}         

        //Un contrusctor por default
        public wrpUserRedirect(){
            this.nombreUsuarioSdf = '';
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpUserRedirect(String nombreUsuarioSdf){
            this.nombreUsuarioSdf = nombreUsuarioSdf;
        }//Fin si wrpListaDealers        
    }

    //Obtener getDatosCandidato. TAM_FechaCitaConcretada__c
    @AuraEnabled
    public static TAM_WrpResultadoActualizacion getNoDistlUserActual() {
        System.debug('En getNoDistlUserActual noDistAct...');
        String strNoDistlUserActual = '';
        
        String strIdUserActual = UserInfo.getUserId();
        String strGestorLeads = '';
        
        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos se actualizarón con exito.');		
        
        //Busca el perfil del usuario
        for (User usuario : [Select u.id, u.CodigoDistribuidor__c From User u
                             Where u.id =: UserInfo.getUserId() ]){
                                 strNoDistlUserActual = usuario.CodigoDistribuidor__c != null ? usuario.CodigoDistribuidor__c : '57000';		
                             }
        System.debug('En getNoDistlUserActual strNoDistlUserActual: ' + strNoDistlUserActual);
        
        //Ve si esta usuario es el mismo que el gestor de Leads para que poueda hacer esta tarea
        for (Account cteGestorLeads : [Select id, TAM_GestorLeads__c From Account 
            Where Codigo_Distribuidor__c =:strNoDistlUserActual ]){
            strGestorLeads += UserInfo.getUserId(); //cteGestorLeads.TAM_GestorLeads__c; 	
            System.debug('En getNoDistlUserActual cteGestorLeads.TAM_GestorLeads__c: ' + cteGestorLeads.TAM_GestorLeads__c + ' Usuraio Actual: ' + UserInfo.getUserId());	
            //Ve si el usuario actual es el mismo que el gestor de leas para este dist
            if (strGestorLeads != strIdUserActual)
               objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'No tienes permiso para ejecutar este proceso.');
            if (strGestorLeads == strIdUserActual){
               objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Tienes permiso para ejecutar este proceso.');
               objRespoPaso.strParamOpcional2 = strNoDistlUserActual;
            }
        }
        System.debug('En getNoDistlUserActual objRespoPaso: ' + objRespoPaso);
        return objRespoPaso;
        
    }

    //Obtener getDatosCandidato.
    @AuraEnabled
    public static wrpDelaerUsruario clsGetListaDealerRedirect (String IdUsrActual) {
        System.debug('En clsGetListaDealerRedirect  IdUsrActual: ' + IdUsrActual);
        String strCadenaDeBusqueda = '';
        String sCodDist;
        String sUsrRole;
        String sUsrId;
        String sUsrNomDist;
        String sNomUsr;

        Boolean blnConsEjec = false;
        Boolean blnConsGest = false;
        Boolean blnConsAsesor = false;
        Boolean blnMuestraLD = false;
        Boolean blnMuestraLUD = false;        
        Boolean blnRedireccionaLeads = false;        

        Set<String> setIdGrupoColab = new Set<String>();
        Set<String> setIdUsrColab = new Set<String>();
        Set<String> setIdUsrRole = new Set<String>();
        Set<String> setNomUsrRole = new Set<String>();
        Set<String> setIdUsrfinal = new Set<String>();
        Map<String, List<TAM_UsuariosSeguimientoLead__c>> mapCodDealerObjUsr = new Map<String, List<TAM_UsuariosSeguimientoLead__c>>();        
        Map<String, TAM_UsuariosSeguimientoLead__c> mapIdExtObjUsr = new Map<String, TAM_UsuariosSeguimientoLead__c>();     
        Map<String, String> mapCodDealerNom = new Map<String, String>();        
        Map<String, User> mapIdUseEjec = new Map<String, User>();
        List<wrpListaUsuariosDist> lUsrDealers = new List<wrpListaUsuariosDist>();
        wrpDelaerUsruario objWrpDelaerUsruario = new wrpDelaerUsruario();
        wrpDealerRedirect objWrpDealerRedirectPaso = new wrpDealerRedirect();
        List<wrpListaUsuariosDist> lwrpUserRedirectPaso = new List<wrpListaUsuariosDist>();
        List<wrpDelaerRel> lWrpDealerRel = new List<wrpDelaerRel>(); 
        Set<String> setIdSuperUsr = new Set<String>();
        Set<String> setIdUsrReal = new Set<String>();
        Set<String> setNomGpoRel = new Set<String>();
        String sIdUsrGestorLeads = '';
        Boolean blUsrGestorLeads = false;
        
        //Busca el Role en el portal
        for (User usuarioActual : [Select id, CodigoDistribuidor__c, UserRoleId, UserRole.PortalRole,
            TAM_RedireccionaLeads__c From User Where Id =:UserInfo.getUserId() ]){
            sCodDist = usuarioActual.CodigoDistribuidor__c;
            sUsrRole = usuarioActual.UserRole.PortalRole;
            sUsrId = Test.isRunningTest() ? IdUsrActual : UserInfo.getUserId();
            blnRedireccionaLeads = usuarioActual.TAM_RedireccionaLeads__c;
        }
        System.debug('En clsGetListaDealerRedirect  sCodDist: ' + sCodDist + ' sUsrRole: ' + sUsrRole + ' sUsrId: ' + sUsrId + ' blnRedireccionaLeads: ' + blnRedireccionaLeads);
        
        for (Account objDist : [Select id, Name, TAM_GestorLeads__c 
            From Account Where Codigo_Distribuidor__c =:sCodDist ]){
            sUsrNomDist = objDist.Name;
            sIdUsrGestorLeads = objDist.TAM_GestorLeads__c;
        }
        //Es una prueba
        if (Test.isRunningTest()){
           sUsrNomDist = 'Toyota Innova Fleteros';
           sCodDist = '57000';
        } 
        System.debug('En clsGetListaDealerRedirect  sCodDist: ' + sCodDist + ' sUsrRole: ' + sUsrRole + ' sUsrId: ' + sUsrId + ' sUsrNomDist: ' + sUsrNomDist);
        
        blnConsEjec = sUsrRole == 'Executive' ? true : false;
        blnConsGest = sUsrRole == 'Manager' ? true : false;
        blnConsAsesor = sUsrRole == 'Worker' ? true : false;
        
        List<wrpDelaer> lWrpListaDealersRedirect = new List<wrpDelaer>();

        //Consulta todos los usuarios asociados al Delaer.
        if (sCodDist == null)
            sCodDist = '57000';

        //Se trata del ejecutivo y tal vez tenga una colaboración especial
        if ( (blnConsEjec && blnRedireccionaLeads) || Test.isRunningTest()){
            blnMuestraLD = true;
            blnMuestraLUD = true;        
            
            //El usuario que esta entrando es el mismo que el gestor
            if (sIdUsrGestorLeads == UserInfo.getUserId())
                blUsrGestorLeads = true;
                
            //Consulta el objeto de TAM_RedireccionaLeads__c y ve si existe un reg asociaso
            for (TAM_RedireccionaLeads__c objPaso : [Select Id, Name, TAM_CodigoDealerOrgen__c, 
                TAM_IdExterno__c, TAM_Activo__c, TAM_UsuariosRelacionados__c 
                From TAM_RedireccionaLeads__c Where TAM_CodigoDealerOrgen__c =:sCodDist 
                And TAM_Principal__c = true]){
                String[] lUsrRela = objPaso.TAM_UsuariosRelacionados__c != null ? 
                    (objPaso.TAM_UsuariosRelacionados__c.contains(';') ? 
                     objPaso.TAM_UsuariosRelacionados__c.split(';') : new List<String>()) 
                    : new List<String>();
                //Recorre la lista de lUsrRela
                for (String sUsrPaso : lUsrRela){
                    setIdUsrReal.add(sUsrPaso);    
                }//Fin del for para lUsrRela
            }
            System.debug('En clsGetListaDealerRedirect  setIdUsrReal: ' + setIdUsrReal);

            //Consulta todos los Delaer relasionados en el gripo de 
            String sNomGrupoPrinc = sUsrNomDist.replace('Toyota', 'Grupo') + ' ' + sCodDist; //Toyota Innova Fleteros
            System.debug('En clsGetListaDealerRedirect  sNomGrupoPrinc: ' + sNomGrupoPrinc);
            //Ve por los miembros del grupo            
            for (GroupMember grupoMemDealerColabora : [Select g.UserOrGroupId, g.GroupId, g.Group.Name 
                From GroupMember g Where g.Group.Name =: sNomGrupoPrinc]){
                System.debug('En clsGetListaDealerRedirect  grupoMemDealerColabora: ' + grupoMemDealerColabora);
                String sIdUsrGrp = grupoMemDealerColabora.UserOrGroupId;
                if (sIdUsrGrp.startsWith('005'))
                    setIdSuperUsr.add(grupoMemDealerColabora.UserOrGroupId);
            }//Fin del for para GroupMember
            //Es una prueba 
            if (Test.isRunningTest())
               setIdSuperUsr.add(UserInfo.getUserId());            
            System.debug('En clsGetListaDealerRedirect  setIdSuperUsr: ' + setIdSuperUsr);
            
            //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
            for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
                TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c  
                 From TAM_UsuariosSeguimientoLead__c Where TAM_IdUsuarioPartner__c IN :setIdSuperUsr 
                 And TAM_ActivoSFDC__c = true Order by Name]){
               //Inicializa el nombre del usuario      
               if (sUsrId == objUsr.TAM_IdUsuarioPartner__c)
                    sNomUsr = objUsr.TAM_NombreCompleto__c; 
               //Metelo al mapa de mapCodDealerObjUsr
               if (mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.get(objUsr.TAM_NoDistribuidor__c).add(objUsr);               
               if (!mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.put(objUsr.TAM_NoDistribuidor__c, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
            }
            System.debug('En clsGetListaDealerRedirect  mapCodDealerObjUsr: ' + mapCodDealerObjUsr.keyset());
            System.debug('En clsGetListaDealerRedirect  mapCodDealerObjUsr: ' + mapCodDealerObjUsr.values());
            
            Map<String, User> mapIdUsrOpbjUsr = new Map<String, User>(); 
            //Busca el perfil del usuario
            for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
                u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name From User u
                Where u.CodigoDistribuidor__c != null and u.IsActive = true And id IN :setIdSuperUsr
                Order by u.CodigoDistribuidor__c,  u.Name]){
                //Agregalo al mapa de mapIdUsrOpbjUsr
                mapIdUsrOpbjUsr.put(usuario.id, usuario);                    
            }//Fin del for para usuario*/
            //Una prueba 
            if (Test.isRunningTest()){
	            for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
	                u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name From User u
	                Where u.IsActive = true And id =:UserInfo.getUserId() Order by u.CodigoDistribuidor__c,  u.Name]){
	                //Agregalo al mapa de mapIdUsrOpbjUsr
	                mapIdUsrOpbjUsr.put(usuario.id, usuario);                    
	            }//Fin del for para usuario*/                
            }//Fin si Test.isRunningTest()
            System.debug('En clsGetListaDealerRedirect  mapIdUsrOpbjUsr: ' + mapIdUsrOpbjUsr.keyset());
            System.debug('En clsGetListaDealerRedirect  mapIdUsrOpbjUsr: ' + mapIdUsrOpbjUsr.values());

            //Recorre el mapa de 
            for (String sIdUsr : mapIdUsrOpbjUsr.keySet()){
                User usuario = mapIdUsrOpbjUsr.get(sIdUsr);
                System.debug('EN getClientesCorporativos usuario: ' + usuario);
                System.debug('EN getClientesCorporativos Profile: ' + usuario.Profile.Name);
                //Crea el id externos
                String sIdExt = usuario.CommunityNickname + '-' + usuario.CodigoDistribuidor__c;    
                String sPerfilPaso = usuario.Profile.Name;
                String sPerfilFinal = sPerfilPaso.length() > 25 ? sPerfilPaso.substring(0, 25) : sPerfilPaso;
                System.debug('EN getClientesCorporativos sIdExt: ' + sIdExt.toUpperCase() + ' sPerfilFinal: ' + sPerfilFinal + ' usuario.Contact.Title: ' + usuario.Contact.Title);
                List<TAM_UsuariosSeguimientoLead__c> lPasoUsr = mapCodDealerObjUsr.containsKey(usuario.CodigoDistribuidor__c) ? mapCodDealerObjUsr.get(usuario.CodigoDistribuidor__c) : new List<TAM_UsuariosSeguimientoLead__c>(); 
                String sNomComp = '';
                //Dale buelta a la lista de TAM_UsuariosSeguimientoLead__c
                for (TAM_UsuariosSeguimientoLead__c objPasoUsr : lPasoUsr){
                    if (objPasoUsr.TAM_IdUsuarioPartner__c == usuario.id){
                        sNomComp = objPasoUsr.TAM_NombreCompleto__c;
                        break;
                    }//Fin si objPasoUsr.TAM_IdUsuarioPartner__c == usuario.id
                }//Fin del for para TAM_UsuariosSeguimientoLead__c
                //Crea el objeto del tipo wrpListaUsuariosDist
                wrpListaUsuariosDist objWrpListaUsuariosDistPaso = new wrpListaUsuariosDist(
                    sNomComp, 
                    usuario.CommunityNickname, 
                    usuario.Email, 
                    usuario.Contact.Title != null ? usuario.Contact.Title : '',
                    sPerfilFinal, 
                    !setIdUsrReal.isEmpty() ? (setIdUsrReal.contains(usuario.id) ? true : false) : false,   ////(mapIdExtObjUsr.containsKey(sIdExt.toUpperCase()) ? mapIdExtObjUsr.get(sIdExt.toUpperCase()).TAM_Activo__c : false), 
                    usuario.id, 
                    0,
                    0,
                    0
                );
                objWrpListaUsuariosDistPaso.strCodigoDealer = usuario.CodigoDistribuidor__c;
                objWrpListaUsuariosDistPaso.blnMuestCodDealer = blnRedireccionaLeads;
                //Agregalo a la lista de lUsrDealers
                lwrpUserRedirectPaso.add(objWrpListaUsuariosDistPaso);                
            }//Fin del for para mapIdUsrOpbjUsr.keySet()
            System.debug('En clsGetListaDealerRedirect lwrpUserRedirectPaso: ' + lwrpUserRedirectPaso);

            String sNomGrupoCol = sUsrNomDist.replace('Toyota', 'Grupo') + ' ' + sCodDist + ' Colabora'; //Toyota Innova Fleteros
            System.debug('En clsGetListaDealerRedirect  sNomGrupoCol: ' + sNomGrupoCol);
            //Ve por los miembros del grupo            
            for (GroupMember grupoMemDealerColabora : [Select g.UserOrGroupId, g.GroupId, g.Group.Name 
                From GroupMember g Where g.Group.Name =: sNomGrupoCol]){
                System.debug('En clsGetListaDealerRedirect  grupoMemDealerColabora: ' + grupoMemDealerColabora);
                String sIdUsrGrp = grupoMemDealerColabora.UserOrGroupId;
                if (sIdUsrGrp.startsWith('00G'))
                    setIdGrupoColab.add(grupoMemDealerColabora.UserOrGroupId);
            }//Fin del for para GroupMember
            System.debug('En clsGetListaDealerRedirect  setIdGrupoColab: ' + setIdGrupoColab);

            //Consulta los datos de los grupos asociados a setIdGrupoColab
            for (Group usrGrupDealerColabora : [Select g.id, g.Type, g.Related.Name, g.Related.FirstName, 
                g.RelatedId From Group g Where id IN: setIdGrupoColab Order by Name]){
                String sNomDistPaso = usrGrupDealerColabora.Related.Name;
                String sNomDistFinal = sNomDistPaso.replace('Socio Ejecutivo', '').replace('Socio Gestor', '').replace('Socio Usuario', '');
                //Agrega el nombre del distribuidor al set de setNomGpoRel
                System.debug('En clsGetListaDealerRedirect sNomDistFinal: ' + sNomDistFinal +' usrGrupDealerColabora: ' + usrGrupDealerColabora);
                setNomGpoRel.add(sNomDistFinal.trim());
            }//Fin del for para GroupMember
            System.debug('En clsGetListaDealerRedirect  setNomGpoRel: ' + setNomGpoRel);
            
            Map<String, String> mapCodDist = new Map<String, String>();
            //Busca los usuarios asociados a setNomGpoRel
	        for (Account objDist : [Select id, Name, Codigo_Distribuidor__c 
	            From Account Where Name IN :setNomGpoRel ]){
	            //Mete los datos del distribuidor a setCodDist
	            mapCodDist.put(objDist.Codigo_Distribuidor__c, objDist.Name);
	        }
            System.debug('En clsGetListaDealerRedirect  mapCodDist: ' + mapCodDist);

            Set<String> setIdUsr = new Set<String>();
            Map<String, List<TAM_UsuariosSeguimientoLead__c>> mapCodDealerObjUsrRel = new Map<String, List<TAM_UsuariosSeguimientoLead__c>>();
            //Ahora consulta los usuarfios asociados a setCodDist del objeto del 
            for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
                TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c  
                 From TAM_UsuariosSeguimientoLead__c Where TAM_NoDistribuidor__c IN :mapCodDist.keyset() 
                 And TAM_ActivoSFDC__c = true Order by Name]){
               //Metelo al mapa de mapCodDealerObjUsrRel
               if (mapCodDealerObjUsrRel.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsrRel.get(objUsr.TAM_NoDistribuidor__c).add(objUsr);               
               if (!mapCodDealerObjUsrRel.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsrRel.put(objUsr.TAM_NoDistribuidor__c, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
               if (objUsr.TAM_IdUsuarioPartner__c != null)
                setIdUsr.add(objUsr.TAM_IdUsuarioPartner__c);
            }
            System.debug('En clsGetListaDealerRedirect  mapCodDealerObjUsrRel: ' + mapCodDealerObjUsrRel.keyset());
            System.debug('En clsGetListaDealerRedirect  mapCodDealerObjUsrRel: ' + mapCodDealerObjUsrRel.values());
            System.debug('En clsGetListaDealerRedirect  setIdUsr: ' + setIdUsr);

            Map<String, User> mapIdUsrOpbjUsrRel = new Map<String, User>(); 
            //Busca el perfil del usuario
            for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
                u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name From User u
                Where u.CodigoDistribuidor__c != null and u.IsActive = true And id IN :setIdUsr
                Order by u.CodigoDistribuidor__c,  u.Name]){
                //Agregalo al mapa de mapIdUsrOpbjUsr
                mapIdUsrOpbjUsrRel.put(usuario.id, usuario);                    
            }//Fin del for para usuario*/
            //Una prueba 
            if (Test.isRunningTest()){
                for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
                    u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name From User u
                    Where u.IsActive = true And id =:UserInfo.getUserId() Order by u.CodigoDistribuidor__c,  u.Name]){
                    //Agregalo al mapa de mapIdUsrOpbjUsr
                    mapIdUsrOpbjUsrRel.put(usuario.id, usuario);                    
                }//Fin del for para usuario*/                
            }//Fin si Test.isRunningTest()
            System.debug('En clsGetListaDealerRedirect  mapIdUsrOpbjUsrRel: ' + mapIdUsrOpbjUsrRel.keyset());
            System.debug('En clsGetListaDealerRedirect  mapIdUsrOpbjUsrRel: ' + mapIdUsrOpbjUsrRel.values());
            
            lWrpDealerRel = new List<wrpDelaerRel>(); 
            //Recorre el mapa de mapCodDealerObjUsrRel y crea los objetos del tipo  wrpDelaerRel
            for (String sCodDealerPaso : mapCodDealerObjUsrRel.keySet()){
                //Una lista del tipo wrpListaUsuariosDist
                List<wrpListaUsuariosDist> lWrpListaUsuariosDist = new List<wrpListaUsuariosDist>();
                //Recorre la lista de usuarios del sCodDealerPaso
                for (TAM_UsuariosSeguimientoLead__c objUsrPaso : mapCodDealerObjUsrRel.get(sCodDealerPaso)){
                    User objUserPaso = mapIdUsrOpbjUsrRel.get(objUsrPaso.TAM_IdUsuarioPartner__c);
                    System.debug('En clsGetListaDealerRedirect  objUserPaso: ' + objUserPaso);
                    String sPerfilPaso = objUserPaso.Profile.Name;
                    String sPerfilFinal = sPerfilPaso.length() > 25 ? sPerfilPaso.substring(0, 25) : sPerfilPaso;
	                //Crea el objeto del tipo wrpListaUsuariosDist
	                wrpListaUsuariosDist objWrpListaUsuariosDistPaso = new wrpListaUsuariosDist(
	                    objUsrPaso.TAM_NombreCompleto__c, 
                        objUserPaso.CommunityNickname, 
	                    objUserPaso.Email, 
	                    objUserPaso.Contact.Title != null ? objUserPaso.Contact.Title : '',
	                    sPerfilFinal, 
	                    objUsrPaso.TAM_Activo__c, 
	                    objUserPaso.id, 
	                    0,
	                    0,
	                    0
	                );
	                objWrpListaUsuariosDistPaso.strCodigoDealer = objUsrPaso.TAM_NoDistribuidor__c;
	                objWrpListaUsuariosDistPaso.blnMuestCodDealer = false;                    
                    //Agrega el objeto objWrpListaUsuariosDistPaso a la lista de lWrpListaUsuariosDist
                    lWrpListaUsuariosDist.add(objWrpListaUsuariosDistPaso);
                }//Fin del for para mapCodDealerObjUsrRel.get(sCodDealerPaso)
                System.debug('En clsGetListaDealerRedirect  lWrpListaUsuariosDist: ' + lWrpListaUsuariosDist);
                //Crea un objeto del tipo wrpDelaer 
                wrpDelaer objDealer = new wrpDelaer(sCodDealerPaso, mapCodDist.get(sCodDealerPaso));
                System.debug('En clsGetListaDealerRedirect  objDealer: ' + objDealer);
                //Agrega el nuevo objeto a la lista de lWrpDealerRel
                lWrpDealerRel.add(new wrpDelaerRel(objDealer, lWrpListaUsuariosDist));
            }//Fin del for para 
            System.debug('En clsGetListaDealerRedirect  lWrpDealerRel: ' + lWrpDealerRel);
            
        }//Fin si blnConsEjec

        //Se trata del ejecutivo y tal vez tenga una colaboración especial
        if ( ((blnConsEjec || blnConsGest ) && !blnRedireccionaLeads) || Test.isRunningTest() ){
            
            //El usuario que esta entrando es el mismo que el gestor
            if (sIdUsrGestorLeads == UserInfo.getUserId())
                blUsrGestorLeads = true;
            
            Set<String> setIdUsrRel = new Set<String>();
            //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
            for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
                TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c  
                 From TAM_UsuariosSeguimientoLead__c Where TAM_NoDistribuidor__c =:sCodDist 
                 And TAM_ActivoSFDC__c = true Order by Name]){
               //Inicializa el nombre del usuario      
               if (sUsrId == objUsr.TAM_IdUsuarioPartner__c)
                    sNomUsr = objUsr.TAM_NombreCompleto__c; 
               //Agregalo a la lista de setIdUsrRel
               setIdUsrRel.add(objUsr.TAM_IdUsuarioPartner__c);
               //Metelo al mapa de mapCodDealerObjUsr
               if (mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.get(objUsr.TAM_NoDistribuidor__c).add(objUsr);               
               if (!mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.put(objUsr.TAM_NoDistribuidor__c, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
            }
            System.debug('En clsGetListaDealerRedirect  setIdUsrRel: ' + setIdUsrRel);

            Map<String, User> mapIdUsrOpbjUsr = new Map<String, User>(); 
            //Busca el perfil del usuario
            for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
                u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name From User u
                Where u.CodigoDistribuidor__c != null and u.IsActive = true And id IN :setIdUsrRel
                Order by u.CodigoDistribuidor__c,  u.Name]){
                //Agregalo al mapa de mapIdUsrOpbjUsr
                mapIdUsrOpbjUsr.put(usuario.id, usuario);                    
            }//Fin del for para usuario*/
            //Una prueba 
            if (Test.isRunningTest()){
                for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
                    u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name From User u
                    Where u.IsActive = true And id =:UserInfo.getUserId() Order by u.CodigoDistribuidor__c,  u.Name]){
                    //Agregalo al mapa de mapIdUsrOpbjUsr
                    mapIdUsrOpbjUsr.put(usuario.id, usuario);                    
                }//Fin del for para usuario*/                
            }//Fin si Test.isRunningTest()
            System.debug('En clsGetListaDealerRedirect  mapIdUsrOpbjUsr: ' + mapIdUsrOpbjUsr.keyset());
            System.debug('En clsGetListaDealerRedirect  mapIdUsrOpbjUsr: ' + mapIdUsrOpbjUsr.values());

            //Recorre el mapa de 
            for (String sIdUsr : mapIdUsrOpbjUsr.keySet()){
                User usuario = mapIdUsrOpbjUsr.get(sIdUsr);
                System.debug('EN getClientesCorporativos usuario: ' + usuario);
                System.debug('EN getClientesCorporativos Profile: ' + usuario.Profile.Name);
                //Crea el id externos
                String sIdExt = usuario.CommunityNickname + '-' + usuario.CodigoDistribuidor__c;    
                String sPerfilPaso = usuario.Profile.Name;
                String sPerfilFinal = sPerfilPaso.length() > 25 ? sPerfilPaso.substring(0, 25) : sPerfilPaso;
                System.debug('EN getClientesCorporativos sIdExt: ' + sIdExt.toUpperCase() + ' sPerfilFinal: ' + sPerfilFinal + ' usuario.Contact.Title: ' + usuario.Contact.Title);
                List<TAM_UsuariosSeguimientoLead__c> lPasoUsr = mapCodDealerObjUsr.containsKey(usuario.CodigoDistribuidor__c) ? mapCodDealerObjUsr.get(usuario.CodigoDistribuidor__c) : new List<TAM_UsuariosSeguimientoLead__c>(); 
                String sNomComp = '';
                //Dale buelta a la lista de TAM_UsuariosSeguimientoLead__c
                for (TAM_UsuariosSeguimientoLead__c objPasoUsr : lPasoUsr){
                    if (objPasoUsr.TAM_IdUsuarioPartner__c == usuario.id){
                        sNomComp = objPasoUsr.TAM_NombreCompleto__c;
                        break;
                    }//Fin si objPasoUsr.TAM_IdUsuarioPartner__c == usuario.id
                }//Fin del for para TAM_UsuariosSeguimientoLead__c
                //Crea el objeto del tipo wrpListaUsuariosDist
                wrpListaUsuariosDist objWrpListaUsuariosDistPaso = new wrpListaUsuariosDist(
                    sNomComp, 
                    usuario.CommunityNickname, 
                    usuario.Email, 
                    usuario.Contact.Title != null ? usuario.Contact.Title : '',
                    sPerfilFinal, 
                    (mapIdExtObjUsr.containsKey(sIdExt.toUpperCase()) ? mapIdExtObjUsr.get(sIdExt.toUpperCase()).TAM_Activo__c : false), 
                    usuario.id, 
                    0,
                    0,
                    0
                );
                objWrpListaUsuariosDistPaso.strCodigoDealer = usuario.CodigoDistribuidor__c;
                objWrpListaUsuariosDistPaso.blnMuestCodDealer = blnRedireccionaLeads;
                //Agregalo a la lista de lUsrDealers
                lUsrDealers.add(objWrpListaUsuariosDistPaso);
            }//Fin del for para mapIdUsrOpbjUsr.keySet()
            System.debug('En clsGetListaDealerRedirect lwrpUserRedirectPaso: ' + lwrpUserRedirectPaso);

        }//Fin si (blnConsEjec || blnConsGest ) && !blnRedireccionaLeads) || Test.isRunningTest()

        System.debug('En clsGetListaDealerRedirect mapCodDealerObjUsr: ' + mapCodDealerObjUsr.values());
        System.debug('En clsGetListaDealerRedirect mapCodDealerObjUsr: ' + mapCodDealerObjUsr.values());       
        System.debug('En clsGetListaDealerRedirect sNomUsr: ' + sNomUsr);
        System.debug('En clsGetListaDealerRedirect blnMuestraLD: ' + blnMuestraLD);
        System.debug('En clsGetListaDealerRedirect blnMuestraLUD: ' + blnMuestraLUD);
        
        Set<String> setCodGrupoNom = new Set<String>();
        //Recorre el mapa de mapNomUsrWrpsuario y llena el objeto de objWrpDelaerUsruario
        for (String sCodDeal : mapCodDealerObjUsr.keyset()){
            for (TAM_UsuariosSeguimientoLead__c objPaso : mapCodDealerObjUsr.get(sCodDeal)){
                setCodGrupoNom.add(sCodDeal + ' - ' + objPaso.TAM_NombreDistribuidor__c);    
            }
        }
        System.debug('En clsGetListaDealerRedirect  setCodGrupoNom: ' + setCodGrupoNom);       
        
        List<wrpDelaer> lDealers = new List<wrpDelaer>();
                
        //Recorre el mapa de mapCodDealerNomFinal y crea los objetos del tipo wrpDelaer
        for (String sNomDealer : setNomGpoRel){
            lDealers.add(new wrpDelaer(sNomDealer, sNomDealer));
        }
        System.debug('En clsGetListaDealerRedirect  lDealers: ' + lDealers);        
        System.debug('En clsGetListaDealerRedirect  lUsrDealers: ' + lUsrDealers);

        //Inicializa el objeto de objWrpDelaerUsruario        
        objWrpDelaerUsruario = new wrpDelaerUsruario(lDealers, lUsrDealers, objWrpDealerRedirectPaso);
        objWrpDelaerUsruario.lUsuariosRedirect = lwrpUserRedirectPaso;
        objWrpDelaerUsruario.blnLstReasigLeads = blnRedireccionaLeads;
        objWrpDelaerUsruario.blnGestorLeads = blUsrGestorLeads;
        objWrpDelaerUsruario.lWrpDealerRel = lWrpDealerRel;
        
        System.debug('En clsGetListaDealerRedirect objWrpDelaerUsruario: ' + objWrpDelaerUsruario);
        //Regresa la lista de Dealers
        return objWrpDelaerUsruario;
    }
    
    //Obtener getDatosCandidato.
    @AuraEnabled
    public static List<wrpListaUsuariosDist> getUsuarosDealer(String noDistAct) {
        System.debug('En getUsuarosDealer noDistAct: ' + noDistAct);
        String strCadenaDeBusqueda = '';
        List<wrpListaUsuariosDist> lWrpListaUsuariosDist = new List<wrpListaUsuariosDist>();
        String noDistActPaso = noDistAct != null ? noDistAct : '57021';
        Map<String, Integer> mapIdLeadTotLead = new Map<String, Integer>();		
        Map<String, Integer> mapIdLeadTotLead2M = new Map<String, Integer>();		
        Map<String, Integer> mapIdLeadTotLead3M = new Map<String, Integer>();
        Set<String> setUsr = new Set<String>();
        Map<String, TAM_UsuariosSeguimientoLead__c> mapIdExtObjUsr = new Map<String, TAM_UsuariosSeguimientoLead__c>();		
        
        //Busca a los usr asociados a noDistAct
        for (User objUser : [Select u.id, u.Name, u.CommunityNickname From User u
                             Where u.CodigoDistribuidor__c != null 
                             And u.IsActive = true And u.CodigoDistribuidor__c =: noDistActPaso ]){
                                 System.debug('En getUsuarosDealer objUser.Name: ' + objUser.Name);				
                                 setUsr.add(objUser.id);
                             }
        
        //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
        for (TAM_UsuariosSeguimientoLead__c objUsrSegLead : [select id, Name, TAM_NoDistribuidor__c, 
            TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c 
             From TAM_UsuariosSeguimientoLead__c Where TAM_NoDistribuidor__c =:noDistAct 
             And TAM_ActivoSFDC__c = true Order by Name]){
            String sIdExtPaso = objUsrSegLead.TAM_IdExterno__c; //objUsrSegLead.Name + '-' + objUsrSegLead.TAM_NoDistribuidor__c;
            System.debug('EN getClientesCorporativos sIdExtPaso: ' + sIdExtPaso);
            //Agregalo al mapa de mapIdExtObjUsr
            mapIdExtObjUsr.put(sIdExtPaso.toUpperCase(), objUsrSegLead); //objUsrSegLead.TAM_IdExterno__c
        }
        System.debug('EN getClientesCorporativos mapIdExtObjUsr: ' + mapIdExtObjUsr);
        
        //Consulta el total del lead asociados a cada setUsr para el mes actual
        for (AggregateResult aggr : [ Select OwnerId, Count(id) totCandidatos 
                                     FROM Lead Where OwnerId IN :setUsr And CreatedDate = THIS_MONTH
                                     And Status != 'Baja de prospecto' Group By OwnerId]){
                                         //Mete a un mapa el total
                                         String sIdCandidato = (String) aggr.get('OwnerId');
                                         Decimal dCntIntTot = (Decimal) aggr.get('totCandidatos'); //(decimal)agg.get('amts'); 
                                         mapIdLeadTotLead.put(sIdCandidato, Integer.valueOf(dCntIntTot));            
                                         System.debug('EN getClientesCorporativos sIdCandidato: ' + sIdCandidato + ' dCntIntTot: ' + dCntIntTot);
                                     }
        System.debug('EN getClientesCorporativos mapIdLeadTotLead: ' + mapIdLeadTotLead);
        
        Date dtMesActual = Date.today();
        Date dtMesAnterior1erdia = Date.newInstance(dtMesActual.year(), dtMesActual.month(), 1); 
        Date dtDosMesAnterior =  dtMesAnterior1erdia.addMonths(-2);
        System.debug('EN getClientesCorporativos dtDosMesAnterior: ' + dtDosMesAnterior);

        Date dtUltimoDiaMesAnterior = dtMesAnterior1erdia.addDays(-1);
        Date dtMesAnteriorFinal = Date.newInstance(dtUltimoDiaMesAnterior.year(), dtUltimoDiaMesAnterior.month(), dtUltimoDiaMesAnterior.day());
        System.debug('EN getClientesCorporativos dtMesAnteriorFinal: ' + dtMesAnteriorFinal);  
        //Consulta el total del lead asociados a cada setUsr para el mes actual y el mes anterior
        for (AggregateResult aggr : [ Select OwnerId, Count(id) totCandidatos 
                                     FROM Lead Where OwnerId IN :setUsr And CreatedDate >= : dtDosMesAnterior
                                     And CreatedDate <= : dtMesAnteriorFinal
                                     And Status != 'Baja de prospecto' Group By OwnerId]){
                                         //Mete a un mapa el total
                                         String sIdCandidato = (String) aggr.get('OwnerId');
                                         Decimal dCntIntTot = (Decimal) aggr.get('totCandidatos'); //(decimal)agg.get('amts'); 
                                         mapIdLeadTotLead2M.put(sIdCandidato, Integer.valueOf(dCntIntTot));            
                                         System.debug('EN getClientesCorporativos sIdCandidato: ' + sIdCandidato + ' dCntIntTot: ' + dCntIntTot);
                                     }
        System.debug('EN getClientesCorporativos mapIdLeadTotLead2M: ' + mapIdLeadTotLead2M);
        
        //Dos meses atras del mes actual
        Date dtDosMesesAtras = dtMesActual.addMonths(-2);
        Date dtDosMesesAtrasFinal = Date.newInstance(dtDosMesesAtras.year(), dtDosMesesAtras.month(), 1) ;
        System.debug('EN getClientesCorporativos dtDosMesesAtrasFinal: ' + dtDosMesesAtrasFinal);
        //Consulta el total de bajas de lead asociados a cada setUsr para el mes actual y dos meses atras
        for (AggregateResult aggr : [ Select OwnerId, Count(id) totCandidatos 
                                     FROM Lead Where OwnerId IN :setUsr And CreatedDate >= : dtDosMesesAtrasFinal
                                     And Status = 'Baja de prospecto' Group By OwnerId]){
                                         //Mete a un mapa el total
                                         String sIdCandidato = (String) aggr.get('OwnerId');
                                         Decimal dCntIntTot = (Decimal) aggr.get('totCandidatos'); //(decimal)agg.get('amts'); 
                                         mapIdLeadTotLead3M.put(sIdCandidato, Integer.valueOf(dCntIntTot));            
                                         System.debug('EN getClientesCorporativos sIdCandidato: ' + sIdCandidato + ' dCntIntTot: ' + dCntIntTot);
                                     }
        System.debug('EN getClientesCorporativos mapIdLeadTotLead3M: ' + mapIdLeadTotLead3M);
        
        //Busca el perfil del usuario
        for (User usuario : [Select u.id, u.Name, u.Email, u.Contact.Puesto__c, u.ContactId, u.Contact.Title, 
            u.CommunityNickname, u.CodigoDistribuidor__c, u.UserRole.Name, Profile.Name, TAM_RedireccionaLeads__c  
            From User u Where u.CodigoDistribuidor__c != null and u.IsActive = true
            And u.CodigoDistribuidor__c =: noDistActPaso Order by u.CodigoDistribuidor__c,  u.Name]){
            System.debug('EN getClientesCorporativos usuario: ' + usuario);
            System.debug('EN getClientesCorporativos Profile: ' + usuario.Profile.Name);
            //Crea el id externos
            String sIdExt = usuario.CommunityNickname + '-' + noDistAct;	
            String sPerfilPaso = usuario.Profile.Name;
            String sPerfilFinal = sPerfilPaso.length() > 25 ? sPerfilPaso.substring(0, 25) : sPerfilPaso;
            System.debug('EN getClientesCorporativos sIdExt: ' + sIdExt.toUpperCase() + ' sPerfilFinal: ' + sPerfilFinal + ' usuario.Contact.Title: ' + usuario.Contact.Title);
            wrpListaUsuariosDist objPaso = new wrpListaUsuariosDist(
                (mapIdExtObjUsr.containsKey(sIdExt.toUpperCase()) ? mapIdExtObjUsr.get(sIdExt.toUpperCase()).TAM_NombreCompleto__c : ''), 
                usuario.CommunityNickname, 
                usuario.Email, 
                usuario.Contact.Title != null ? usuario.Contact.Title : '',
                sPerfilFinal, 
                (mapIdExtObjUsr.containsKey(sIdExt.toUpperCase()) ? mapIdExtObjUsr.get(sIdExt.toUpperCase()).TAM_Activo__c : false), 
                usuario.id, 
                mapIdLeadTotLead.containsKey(usuario.id) ? mapIdLeadTotLead.get(usuario.id) : 0,
                mapIdLeadTotLead2M.containsKey(usuario.id) ? mapIdLeadTotLead2M.get(usuario.id) : 0,
                mapIdLeadTotLead3M.containsKey(usuario.id) ? mapIdLeadTotLead3M.get(usuario.id) : 0
            );
            //Inicializa el resto de los valores
            objPaso.strCodigoDealer = noDistAct;
            objPaso.blnMuestCodDealer = usuario.TAM_RedireccionaLeads__c;
            System.debug('En getUsuarosDealer objPaso: ' + objPaso);
            //agregalo a la lista de lWrpListaUsuariosDist
            lWrpListaUsuariosDist.add(objPaso);
        }
        System.debug('En getUsuarosDealer lWrpListaUsuariosDist: ' + lWrpListaUsuariosDist);
        return lWrpListaUsuariosDist;
    }
    
    //Obtener updateDatosCandidato.
    @AuraEnabled
    public static TAM_WrpResultadoActualizacion clsAcctUsrSegLead(String strNoDist, List<wrpListaUsuariosDist> lUsuariosActivosLeads,
        String sCodDealerSelPrm, wrpDelaerUsruario objWrpDelaerUsruarioPrm){
        System.debug('EN AcctUsrSegLead strNoDist: ' + strNoDist);
        System.debug('EN AcctUsrSegLead lUsuariosActivosLeads: ' + lUsuariosActivosLeads);
        System.debug('EN AcctUsrSegLead sCodDealerSelPrm: ' + sCodDealerSelPrm);
        System.debug('EN AcctUsrSegLead objWrpDelaerUsruarioPrm: ' + objWrpDelaerUsruarioPrm);
        System.debug('EN AcctUsrSegLead objWrpDelaerUsruarioPrm.lWrpDealerRel: ' + objWrpDelaerUsruarioPrm.lWrpDealerRel);
        
        List<TAM_UsuariosSeguimientoLead__c> lUsuariosSeguimientoLeadUps = new List<TAM_UsuariosSeguimientoLead__c>();
        Boolean bError = false;
        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos se actualizarón con exito.');		
        List<TAM_RedireccionaLeads__c> lRedireccionaLeadsUps = new List<TAM_RedireccionaLeads__c>();
        List<TAM_RedireccionaLeads__c> lRedireccionaLeadsDel = new List<TAM_RedireccionaLeads__c>();
        Set<String> setCodDeaNom = new Set<String>();
        Boolean blnUsuarioActivoRedirec = false;
                
        //Recorre la lista de registro de la lista lUsuariosActivosLeads
        for (wrpListaUsuariosDist objWrpListaUsuariosDist : lUsuariosActivosLeads){
            //Crea los objetos del tipo lUsuariosSeguimientoLeadUps
            lUsuariosSeguimientoLeadUps.add(new TAM_UsuariosSeguimientoLead__c(
                Name = objWrpListaUsuariosDist.strNombreUusario,
                TAM_IdExterno__c = objWrpListaUsuariosDist.strAlias + '-' + strNoDist,
                TAM_Activo__c = objWrpListaUsuariosDist.blnActivo,
                TAM_NoDistribuidor__c = strNoDist,
                TAM_IdUsuarioPartner__c = objWrpListaUsuariosDist.strIdUsuario,
                TAM_ContadorLeadAsignado__c  = 0
                )
            );
        }//Fin del for para la lista de lUsuariosActivosLeads
        
        //Un punto de retorno
        SavePoint svInv = Database.setSavepoint();        
        
        //Cosnulta el nombre del dealer asociado sCodDealerSelPrm
        if (!objWrpDelaerUsruarioPrm.lDealers.isEmpty() && objWrpDelaerUsruarioPrm.blnLstReasigLeads){
                        
            String sUsrRedirec = '';
            for (wrpListaUsuariosDist objUserRedir : objWrpDelaerUsruarioPrm.lUsuariosRedirect){
                if (objUserRedir.blnActivo){
                    sUsrRedirec += objUserRedir.strIdUsuario + ';';
                    blnUsuarioActivoRedirec = true;
                }//Fin si objUserRedir.blnActivo
            }//Fin del for para objWrpDelaerUsruarioPrm.lUsuariosRedirect
            System.debug('EN AcctUsrSegLead sUsrRedirec: ' + sUsrRedirec);
	        
            Set<String> setNoDist = new Set<String>();
            for (wrpDelaer objWrpDelaer : objWrpDelaerUsruarioPrm.lDealers){
                setNoDist.add(objWrpDelaer.nombreDist);
            }
            System.debug('EN AcctUsrSegLead setNoDist: ' + setNoDist);
            
            Map<String, String> mapNomDistCod = new Map<String, String>();
            Map<String, String> mapCodNomDist = new Map<String, String>();
            //Consulta los datos de lo Dealer en Account
	        for (Account cteDist : [Select id, Name, Codigo_Distribuidor__c From Account 
	            Where Name IN :setNoDist OR Codigo_Distribuidor__c =: strNoDist]){
                //Agregalo al mapa de mapNomDistCod
                mapNomDistCod.put(cteDist.Name, cteDist.Codigo_Distribuidor__c);
	            mapCodNomDist.put(cteDist.Codigo_Distribuidor__c, cteDist.Name);
	        }//Fin del for para Account
            System.debug('EN AcctUsrSegLead mapNomDistCod: ' + mapNomDistCod.keyset());
            System.debug('EN AcctUsrSegLead mapNomDistCod: ' + mapNomDistCod.values());
            System.debug('EN AcctUsrSegLead mapCodNomDist: ' + mapCodNomDist);
	        
	        if (!blnUsuarioActivoRedirec){
	            for (TAM_RedireccionaLeads__c objRegRedirec : [Select id From TAM_RedireccionaLeads__c 
	               Where TAM_CodigoDealerOrgen__c =:strNoDist ]){
	               //Agregalo a la lista de lRedireccionaLeadsDel
	               lRedireccionaLeadsDel.add(new TAM_RedireccionaLeads__c(id = objRegRedirec.id)); 
	            }//Fin del for para TAM_RedireccionaLeads__c
	        }//Fin si !blnUsuarioActivoRedirec
            System.debug('EN AcctUsrSegLead lRedireccionaLeadsDel: ' + lRedireccionaLeadsDel);

            //Dale la vuelta los Dealer de la lista de lDealers
            if (!objWrpDelaerUsruarioPrm.lDealers.isEmpty()){
                String sDealerSel = strNoDist + '-' + mapCodNomDist.get(strNoDist);
                //Agregalo a la lista de lRedireccionaLeadsUps
                lRedireccionaLeadsUps.add(new TAM_RedireccionaLeads__c(
                    Name = sDealerSel,
                    TAM_IdExterno__c = strNoDist + '-' + strNoDist,
                    TAM_CodigoDealerOrgen__c = strNoDist,
                    TAM_Principal__c = true,
                    TAM_UsuariosRelacionados__c = sUsrRedirec
                    )
                );
                System.debug('EN AcctUsrSegLead lRedireccionaLeadsUps1: ' + lRedireccionaLeadsUps);
                                                
                //Recorre la lista de setCodDeaNom
                for (String sNomDealer : setNoDist){
                    String sCodigoPaso = mapNomDistCod.containsKey(sNomDealer) ? mapNomDistCod.get(sNomDealer) : null;
                    TAM_RedireccionaLeads__c objPaso = new TAM_RedireccionaLeads__c(
                        Name = sDealerSel,
                        TAM_IdExterno__c = strNoDist + '-' + sCodigoPaso,
                        TAM_CodigoDealerOrgen__c = strNoDist,
                        TAM_Principal__c = false,
                        TAM_CodigoDealerRelacionado__c = sCodigoPaso,
                        TAM_UsuariosRelacionados__c = sUsrRedirec                    
                    ); 
                    //Agregalo a la lista de lRedireccionaLeadsUps
                    if (sCodigoPaso != strNoDist && sCodigoPaso != null)
                        lRedireccionaLeadsUps.add(objPaso);                    
                }//Fin del for para setCodDeaNom
            }//Fin si !objWrpDelaerUsruarioPrm.lDealers.isEmty()
            System.debug('EN AcctUsrSegLead lRedireccionaLeadsUps2: ' + lRedireccionaLeadsUps);            
            //Actualiza el registro
            if (blnUsuarioActivoRedirec)
                upsert lRedireccionaLeadsUps TAM_IdExterno__c; 
            if (!blnUsuarioActivoRedirec)
                delete lRedireccionaLeadsDel;                               
        }//Fin si sCodDealerSelPrm != nul

        //Ve si la lista de objWrpDelaerUsruarioPrm.lWrpDealerRel tiene algo 
        for (wrpDelaerRel objWrpDelaerRel : objWrpDelaerUsruarioPrm.lWrpDealerRel){
            String sCodPaso = objWrpDelaerRel.objDealer.codigo;
            System.debug('EN AcctUsrSegLead sCodPasoFinal: ' + sCodPaso);
            //Recorre la lista de usuarios objWrpDelaerRel.lUsrsRel
            for (wrpListaUsuariosDist objWrpListaUsuariosDist : objWrpDelaerRel.lUsrsRel){
                TAM_UsuariosSeguimientoLead__c objUsrPaso = new TAM_UsuariosSeguimientoLead__c(
                    Name = objWrpListaUsuariosDist.strNombreUusario,
                    TAM_IdExterno__c = objWrpListaUsuariosDist.strAlias + '-' + sCodPaso,
                    TAM_Activo__c = objWrpListaUsuariosDist.blnActivo,
                    TAM_NoDistribuidor__c = sCodPaso,
                    TAM_IdUsuarioPartner__c = objWrpListaUsuariosDist.strIdUsuario,
                    TAM_ContadorLeadAsignado__c  = 0
                );
                System.debug('EN AcctUsrSegLead objUsrPasoFinal: ' + objUsrPaso);
	            //Crea los objetos del tipo lUsuariosSeguimientoLeadUps
	            lUsuariosSeguimientoLeadUps.add(objUsrPaso);                
            }//Fin del for para lUsrsRel
        }//Fin del for para objWrpDelaerUsruarioPrm.lWrpDealerRel

        System.debug('EN AcctUsrSegLead lUsuariosSeguimientoLeadUps: ' + lUsuariosSeguimientoLeadUps);        
        //Ve si tiene algo la lista de lUsuariosSeguimientoLeadUps
        if (!lUsuariosSeguimientoLeadUps.isEmpty() && !blnUsuarioActivoRedirec){
            List<Database.UpsertResult> ldtSvr = Database.upsert(lUsuariosSeguimientoLeadUps, TAM_UsuariosSeguimientoLead__c.TAM_IdExterno__c, false);
            for(Database.UpsertResult objSvr : ldtSvr){
                if (!objSvr.isSuccess())
                    objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de Actualizar los datos de los usuarios: ' + objSvr.getErrors()[0].getMessage());
            }
        }//Fin si !lUsuariosSeguimientoLeadUps.isEmpty()

        //Para pruebas despues lo quitas
        //Database.rollback(svInv);
        
        //Regresa el objeto del tipo TAM_WrpResultadoActualizacion
        return objRespoPaso;
        
    }
     
    @AuraEnabled
    public static String consultaMaximoLeads (String userId){
        List<User> usr = new List<User>();
        TAM_MaximoNumeroLeads__c consultaParametro = new TAM_MaximoNumeroLeads__c();
        
        //usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId];
        for (User usuarioPaso : [Select id,CodigoDistribuidor__c FROM User where id =:userId]){
           usr.add(usuarioPaso);
        }

        //consultaParametro = [Select id,TAM_MaximoLeads__c From TAM_MaximoNumeroLeads__c WHERE Id_Externo__c =: usr[0].CodigoDistribuidor__c];   
        if(usr.size() > 0){
            for (TAM_MaximoNumeroLeads__c objMaximoNumeroLeads : [Select id,TAM_MaximoLeads__c From TAM_MaximoNumeroLeads__c 
                WHERE Id_Externo__c =: usr[0].CodigoDistribuidor__c]){
                consultaParametro =  objMaximoNumeroLeads;
            }
        }

        return consultaParametro.TAM_MaximoLeads__c;
    }
    
    
    @AuraEnabled
    public static void seteaValorMaximoLeads(String userId, Integer numeroMaximoLead){   
        User usr = new User ();
        usr = [Select id,CodigoDistribuidor__c FROM User where id =:userId];  
        TAM_MaximoNumeroLeads__c configLeads = new TAM_MaximoNumeroLeads__c();  
        configLeads.TAM_MaximoLeads__c = String.valueOf(numeroMaximoLead);
        configLeads.TAM_CodigoDealer__c  =  usr.CodigoDistribuidor__c;
        configLeads.Id_Externo__c = usr.CodigoDistribuidor__c;
        try{
           upsert configLeads Id_Externo__c ; 
        }catch(Exception e){
           system.debug('Error general al actualizar la propiedad' + e.getMessage()); 
            
        }
   
    }
  
}